#include <cairo.h>

int
main()
{
  cairo_surface_t* src = cairo_image_surface_create_from_png("src.png");
  int width = cairo_image_surface_get_width(src);
  int height = cairo_image_surface_get_height(src);

  double scale = 1.0/4;

  cairo_format_t format = CAIRO_FORMAT_ARGB32;
  cairo_surface_t* dst = cairo_image_surface_create(format,
                                                    width*scale, height*scale);

  cairo_t* cr = cairo_create(dst);

  cairo_scale(cr, scale, scale);

  cairo_pattern_t* pat = cairo_pattern_create_for_surface(src);
  cairo_pattern_set_filter(pat, CAIRO_FILTER_BEST);

  cairo_set_source(cr, pat);
  cairo_paint(cr);

  cairo_pattern_destroy(pat);

  cairo_destroy(cr);

  cairo_surface_write_to_png(dst, "cairo-best.png");
  cairo_surface_destroy(dst);

  cairo_surface_destroy(src);

  return 0;
}
